indexing
	description: "Objects that generate code, needed in clients of IDENTITIES class"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_IDENTITIES_METACLIENT

inherit
	CI_IDENTITIES_NAMES_CLIENT

	CI_CODE_GENERATION
		export {NONE}
			all
		end

create
	make

feature -- Initialization
	make (a_universe: like universe) is
			-- Create generator that works within `a_universe'
		require
			a_universe_exists: a_universe /= Void
		do
			universe := a_universe
		ensure
			universe_set: universe = a_universe
		end

feature -- Access
	feature_clause: ET_FEATURE_CLAUSE is
			-- Feature clause for `query'
		once
			create Result.make (clients_none)
			add_comment ("Identities", Result)
		end

	query (a_client_class: ET_CLASS): ET_ONCE_FUNCTION is
			-- Identities query
		do
			check
				Identities_names.identities_name /= Void
				-- It should have been set by identities generator
			end

			-- Create function signature
			create Result.make (Identities_names.identity_target_name (a_client_class.name),
				Void,
				type_from_class (universe.eiffel_class (Identities_names.identities_name), a_client_class, universe),
				a_client_class)

			-- Create function body
			Result.set_compound (single_instruction (create {ET_CREATE_INSTRUCTION}.make (Void, tokens.result_keyword, Void)))
			Result.compound.set_keyword (tokens.once_keyword)
			Result.set_feature_clause (feature_clause)
		end

feature {NONE} -- Implementation
	universe: ET_UNIVERSE
			-- Surrounding universe

invariant
	universe_exists: universe /= Void
end
