indexing
	description: "Program points within body of specific internal function"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	CI_FUNCTION_BODY_POINT

inherit
	CI_FUNCTION_POINT
		rename
			make as make_with_routine_and_class
		export {NONE}
			make_with_routine_and_class
		redefine
			surrounding_routine,
			add_variables,
			state_printing_function_formals,
			state_printing_function_actuals
		end

	CI_ROUTINE_BODY_POINT
		redefine
			surrounding_routine,
			add_variables,
			state_printing_function_formals,
			state_printing_function_actuals
		end


feature -- Access
	surrounding_routine: ET_INTERNAL_FUNCTION
			-- Function to which program point belongs	

feature {NONE} -- Implementation
	add_variables is
			-- Find variables in scope and store them into `variables'
			-- Call both `Precursor's
		do
			Precursor {CI_FUNCTION_POINT}
			Precursor {CI_ROUTINE_BODY_POINT}
			variables_added := True
		end

feature {NONE} -- Assertions			
	state_printing_function_formals: ET_FORMAL_ARGUMENT_LIST is
			-- Formal arguments of `state_printing_function'
		do
			Result := Precursor {CI_ROUTINE_BODY_POINT}
			if Result = Void then
				create Result.make_with_capacity (1)
			end
			Result.force_first (create {ET_FORMAL_ARGUMENT}.make (corrupted (tokens.result_keyword.text), surrounding_routine.declared_type))
		end

	state_printing_function_actuals: ET_ACTUAL_ARGUMENT_LIST is
			-- Actual arguments of `state_printing_function' call inside instrumented `checked_assertions'
		do
			Result := Precursor {CI_ROUTINE_BODY_POINT}
			if Result = Void then
				create Result.make_with_capacity (1)
			end
			Result.force_first (tokens.result_keyword)
		end
end
