indexing
	description: "Variables that are `Current' entities"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_CURRENT

inherit
	CI_VARIABLE
		redefine
			is_current,
			is_param,
			needs_synonim
		end

	CI_SHARED_TOKEN_CONSTANTS
		undefine
			is_equal	-- Variables are compared by `name'
		end

create
	make

feature -- Initialization
	make (a_surrounding_routine: like surrounding_routine; a_surrounding_class: ET_CLASS; a_universe: ET_UNIVERSE) is
			-- Create a "Current" variable in `a_surrounding_routine' (may be Void) of `a_surrounding_class' in `a_universe'
		require
			a_surrounding_class_exists: a_surrounding_class /= Void
			a_universe_exists: a_universe /= Void
		do
			surrounding_routine := a_surrounding_routine
			create type.make (create {ET_LIKE_CURRENT}.make, a_surrounding_class, a_universe)
			create clients.make
			create evaluation_preconditions.make
			if needs_synonim then
				create synonim.make (synonim_name)
			end
			set_unfolding_depth (Settings.unfolding_depth)
		ensure
			type_exists: type /= Void
		end

feature -- Access
	name: STRING is
			-- String "Current"
		once
			Result := tokens.current_keyword.text
		end

feature -- Evaluation
	as_expression: ET_CURRENT is
			-- "Current" viewed as identifier
		once
			create Result.make
		end

feature {CI_VARIABLE_TYPE_KIND} -- Evaluation
	address_expression: ET_ADDRESS_EXPRESSION is
			-- "Current" address
		do
			create {ET_FEATURE_ADDRESS} Result.make (synonim)
		end

feature -- Status report
	needs_synonim: BOOLEAN is
			-- Does variable need a synonim or `as_expression' can be used everywhere as is?
			-- Yes, if it may be used in address expression ($Current is permitted by ISE, but causes runtime errors)
		do
			Result := type.kind.uses_address
		end

	is_param: BOOLEAN is
			-- Daikon property: variable value can't be changed by routine
		once
			Result := True
		end

feature {CI_VARIABLE} -- Status report
	is_current: BOOLEAN is
			-- Is variable a "Current" entity
		once
			Result := True
		end

invariant
	surrounding_class_is_base_class: type.surrounding_class = type.base_class
end
