indexing
	description: "Variables that are routine's formal arguments'"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_FORMAL_ARGUMENT

inherit
	CI_VARIABLE
		redefine
			is_param,
			needs_synonim
		end

create
	make

feature -- Initialization
	make (a_formal: like ast_node; a_surrounding_routine: like surrounding_routine;
		a_surrounding_class: ET_CLASS; a_universe: ET_UNIVERSE) is
			-- Create a variable that corresponds to `a_formal' of `a_surrounding_routine'
			-- within `a_surrounding_class' in `a_universe'
		require
			a_formal_exists: a_formal /= Void
			a_surrounding_routine_exists: a_surrounding_routine /= Void
			a_surrounding_class_exists: a_surrounding_class /= Void
			a_universe_exists: a_universe /= Void
		do
			ast_node := a_formal
			surrounding_routine := a_surrounding_routine
			create type.make (ast_node.type, a_surrounding_class, a_universe)
			create clients.make
			create evaluation_preconditions.make
			if needs_synonim then
				create synonim.make (synonim_name)
			end
			set_unfolding_depth (Settings.unfolding_depth)
		ensure
			surrounding_routine_set: surrounding_routine = a_surrounding_routine
			ast_node_set: ast_node = a_formal
		end

feature -- Access
	ast_node: ET_FORMAL_ARGUMENT
			-- An AST node that corresponds to variable (used to get static information)

	name: STRING is
			-- String identifier representation
		do
			Result := ast_node.name.lower_name
		end

feature -- Evaluation
	as_expression: ET_IDENTIFIER is
			-- Formal argument viewed as identifier
		do
			Result := ast_node.name
		end

feature {CI_VARIABLE_TYPE_KIND} -- Evaluation
	address_expression: ET_FEATURE_ADDRESS is
			-- Formal argument address
		do
--			create Result.make (ast_node.name)
			create Result.make (synonim)
		end

feature -- Status report
	needs_synonim: BOOLEAN is
			-- Does variable need a synonim or `as_expression' can be used everywhere as is?
		do
			Result := type.kind.uses_address
		end

	is_param: BOOLEAN is
			-- Daikon property: variable value can't be changed by routine
		once
			Result := True
		end

invariant
	ast_node_exists: ast_node /= Void
end
