indexing
	description: "Variables that are function's `Result' entities"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_RESULT

inherit
	CI_VARIABLE
		redefine
			eiffel_name,
			surrounding_routine,
			needs_synonim
		end

create
	make

feature -- Initialization
	make (a_surrounding_function: like surrounding_routine; a_surrounding_class: ET_CLASS; a_universe: ET_UNIVERSE) is
			-- Create a variable that is result of `a_surrounding_function'
			-- of `a_surrounding_class' in `a_universe'
		require
			a_surrounding_function_exists: a_surrounding_function /= Void
			a_surrounding_class_exists: a_surrounding_class /= Void
			a_universe_exists: a_universe /= Void
		do
			surrounding_routine := a_surrounding_function
			create type.make (surrounding_routine.type, a_surrounding_class, a_universe)
			create clients.make
			create evaluation_preconditions.make
			set_unfolding_depth (Settings.unfolding_depth)
			if needs_synonim then
				create synonim.make (synonim_name)
			end
		ensure
			surrounding_routine_set: surrounding_routine = a_surrounding_function
		end

feature -- Access
	name: STRING is
			-- String "return"
		once
			Result := "return"
		end

	eiffel_name: STRING is
			-- String "Result"
		once
			Result := tokens.result_keyword.text
		end

	surrounding_routine: ET_FUNCTION
			-- Routine within which variable can be evaluated

feature -- Evaluation
	as_expression: ET_EXPRESSION is
			-- "Result" viewed as identifier
		do
			if instrumentation_mode_disabled then
				Result := tokens.result_keyword
			else
				Result := corrupted (tokens.result_keyword_name)
			end
		end

feature {CI_VARIABLE_TYPE_KIND} -- Evaluation
	address_expression: ET_FEATURE_ADDRESS is
			-- "Result" address
		do
--			create Result.make (corrupted (tokens.result_keyword_name))
			create Result.make (synonim)
		end

feature -- Status report
	needs_synonim: BOOLEAN is
			-- Does variable need a synonim or `as_expression' can be used everywhere as is?
		do
			Result := type.kind.uses_address
		end
end
