indexing
	description: "Variables that represent string values (fictitious queries on string refernces)"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_STRING_VALUE

inherit
	CI_VARIABLE
		redefine
--			eiffel_name,
			constant
		end

create
	make

feature -- Initialization
	make (a_target: like target) is
			-- Create variable that value of string reference `a_target'
		require
			a_target_exists: a_target /= Void
			a_target_is_string_ref: a_target.type.kind.is_string_reference
		do
			target := a_target
			surrounding_routine := target.surrounding_routine
			create type.make_string_value (target.type.base_class, target.type.context, target.type.universe)
			clients := class_names_twin (target.clients)

			create evaluation_preconditions.make
			evaluation_preconditions.force_first (exists_condition (target.as_expression))
			if needs_synonim then
				create synonim.make (synonim_name)
			end
		ensure
			target_set: target = a_target
		end

feature -- Access
	target: CI_VARIABLE
			-- String reference, whose value is `Current'

	name: STRING is
			-- Variable name in Daikon format (unique within program point)
		do
			Result := target.name.string
			Result.append (suffix)
		end

--	eiffel_name: STRING is
--			-- Variable name, as it will appear in annotated class
--		do
--			Result := target.name.string
--		end

	constant: ET_CONSTANT is
			-- Compile-time constant value of variable (void if not a constant)
		local
			query_var: CI_QUERY
			const_attr: ET_CONSTANT_ATTRIBUTE
		do
			query_var ?= target
			if query_var /= Void then
				const_attr ?= query_var.ast_node
				if const_attr /= Void then
					Result := const_attr.constant
				end
			end
		end

	suffix: STRING is "_value_"

feature -- Evaluation
	as_expression: ET_EXPRESSION is
			-- Variable viewed as Eiffel expression: the same as for `target'
		do
			Result := target.as_expression
		end

feature {CI_VARIABLE_TYPE_KIND} -- Evaluation
	address_expression: ET_FEATURE_ADDRESS is
			-- Is never used
		do
		end

invariant
	target_exists: target /= Void
	printable_kind: type.kind.is_printable
	address_not_used: not type.kind.uses_address
end
